import {
  styleExpressionProperty
} from "./chunk.ADPMTWTS.js";
import {
  text_style_css_default
} from "./chunk.KK4QVD34.js";
import {
  tokens
} from "./chunk.OC725E4N.js";
import {
  GdsElement
} from "./chunk.ZQ4D5K7J.js";
import {
  gdsCustomElement,
  html
} from "./chunk.VOYMQ322.js";
import {
  __decorateClass
} from "./chunk.5VURDMKE.js";

// libs/core/src/components/content/text/text.ts
import { property } from "lit/decorators.js";
var GdsText = class extends GdsElement {
  constructor() {
    super(...arguments);
    this.tag = "p";
  }
  createTag() {
    const tag = document.createElement(this.tag);
    tag.appendChild(document.createElement("slot"));
    return tag;
  }
  render() {
    return html`${this.createTag()}`;
  }
};
// static styles = [tokens, TextCSS, ]
GdsText.styles = [tokens, text_style_css_default];
__decorateClass([
  property({ type: String })
], GdsText.prototype, "tag", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => `${v}`,
    styleTemplate: (prop, values) => {
      const size = values[0];
      return `font-size: var(--gds-text-size-${size}); line-height: var(--gds-text-line-height-${size});`;
    }
  })
], GdsText.prototype, "size", 2);
__decorateClass([
  styleExpressionProperty()
], GdsText.prototype, "margin", 2);
__decorateClass([
  styleExpressionProperty({
    property: "text-wrap",
    valueTemplate: (v) => v
  })
], GdsText.prototype, "wrap", 2);
__decorateClass([
  styleExpressionProperty({
    property: "text-transform",
    valueTemplate: (v) => v
  })
], GdsText.prototype, "transform", 2);
__decorateClass([
  styleExpressionProperty({
    property: "max-width",
    valueTemplate: (v) => `${v}ch`
  })
], GdsText.prototype, "length", 2);
__decorateClass([
  styleExpressionProperty({
    property: "min-width",
    valueTemplate: (v) => `${v}ch`
  })
], GdsText.prototype, "min", 2);
__decorateClass([
  styleExpressionProperty({
    property: "text-align",
    valueTemplate: (v) => v
  })
], GdsText.prototype, "align", 2);
__decorateClass([
  styleExpressionProperty({
    property: "--_lines",
    valueTemplate: (v) => v
  })
], GdsText.prototype, "lines", 2);
__decorateClass([
  styleExpressionProperty({
    property: "color",
    valueTemplate: (v) => {
      const [colorName, transparency] = v.split("/");
      if (transparency) {
        return `color-mix(in srgb, var(--gds-sys-color-${colorName}) ${parseFloat(transparency) * 100}%, transparent 0%)`;
      } else {
        return `var(--gds-sys-color-${colorName})`;
      }
    }
  })
], GdsText.prototype, "color", 2);
GdsText = __decorateClass([
  gdsCustomElement("gds-text")
], GdsText);

export {
  GdsText
};
