// libs/core/src/utils/helpers/constrain-slots.ts
function constrainSlots(self) {
  self.updateComplete.then(() => {
    var _a, _b, _c;
    const slots = (_a = self.shadowRoot) == null ? void 0 : _a.querySelectorAll("slot[gds-allow]");
    if (!slots)
      return;
    for (const node of Array.from(self.childNodes)) {
      if (node.nodeType === Node.TEXT_NODE && ((_b = node.textContent) == null ? void 0 : _b.trim()) === "") {
        (_c = node.parentNode) == null ? void 0 : _c.removeChild(node);
      }
    }
    const constrain = (slot) => {
      var _a2, _b2;
      const allowed = [
        ...((_a2 = slot.getAttribute("gds-allow")) == null ? void 0 : _a2.split(" ")) || [],
        "slot"
      ];
      for (const node of Array.from(slot.assignedNodes())) {
        if (!allowed.includes(node.nodeName.toLowerCase())) {
          (_b2 = node.parentNode) == null ? void 0 : _b2.removeChild(node);
        }
      }
    };
    slots.forEach((slot) => {
      constrain(slot);
      slot.addEventListener("slotchange", () => constrain(slot));
    });
  });
}

export {
  constrainSlots
};
