import { GdsElement } from '../../gds-element';
/**
 * @element gds-menu-button
 * @status beta
 *
 * @slot - Content to be displayed as the button label.
 * @slot lead - An optional slot that allows a `gds-icon` element to be placed before the label.
 * @slot trail - An optional slot that allows a `gds-icon` element to be placed after the label.
 *
 * @event click - Fired when the button is clicked.
 */
export declare class MenuButton extends GdsElement {
    #private;
    static styles: (import("lit").CSSResult | import("lit").CSSResult[])[];
    static shadowRootOptions: ShadowRootInit;
    /**
     * Whether the menu-button is disabled.
     */
    disabled: boolean;
    /**
     * The label of the menu-button. Use this to add an accessible label to the button when no text is provided in the default slot.
     */
    label: string;
    /**
     * When set, the underlying button will be rendered as an anchor element.
     */
    href: string;
    /**
     * Where to display the linked URL. Only used when href is present.
     */
    target?: '_self' | '_blank' | '_parent' | '_top';
    /**
     * The relationship of the linked URL as space-separated link types. Only used when href is present. Defaults to "noreferrer noopener" for security reasons when target is set.
     */
    rel?: string;
    /**
     * Causes the browser to treat the linked URL as a download. Can be used with or without a filename value. Only used when href is present.
     */
    download?: string;
    /**
     * The label of the menu-button. Use this to add an accessible label to the button when no text is provided in the default slot.
     */
    compact: boolean;
    /**
     * Whether the menu button is selected
     */
    selected: boolean;
    constructor();
    render(): import("lit").TemplateResult;
}
